#
#               Common Quantification
#                        of
#              Categorical Variables
#
#             Yasuharu Okamoto, 2016.09, 2018.05
#

import math
import numpy
import scipy.stats as ss
from readdata import *
import cmmnq
import mymodule as mm

def ToFloat(X):
    FX = []
    for v in X:
        FX.append(float(v))
    return FX

print('When the input data file is a text file, key in 1')
print('When the input data file is a CSV file,  key in 2')
ck = input('Your choice (1 or 2) ? = ')
if ck == '1':
    f_out, s_out, n_data, n_vars, var_names, var_cond, X = ReadTextFile()
elif ck == '2':
    f_out, s_out, n_data, n_vars, var_names, var_cond, X = ReadCSVFile()
else:
    print('Invalid choice !');
    raise Exception()


#
#       Xgen:  a matrix of scores, which are the same as the input value for condition = 0,
#                                                standardized scores for conditon = 1,
#                                                or quantifications for conditon >= 2.
#
Xgen = []
pos_v = 0
for i_var in range(0, n_vars):
    if (var_cond[i_var] < 0):                           #  Invalid condition value
        print("var_cond < 0")
        raise "var_cond error."
    else:        
        if (var_cond[i_var] == 0):                     #  No transformation
            Xgen.append([var_names[i_var], X[i_var]])
            pos_v = pos_v + 1
        elif (var_cond[i_var] == 1):                   #  Standardization
            vX = ss.zscore(ToFloat(X[i_var]))
            Xgen.append([var_names[i_var] + '_z', vX])
            pos_v = pos_v + 1
        else:                                           #  Quantification
            vX = X[i_var]
            for iv in range(0, n_data):
                #   print('iv = ', iv)
                #   print('vX = ', vX)
                vX[iv] = int(vX[iv])
            n_quant, eigen_val, matOmega, z = cmmnq.comq(vX, var_cond[i_var], n_data)
            f_out.write("\n")
            f_out.write("Categorical variable: " + var_names[i_var]
                                                 + " quantified.")
            f_out.write("Number of quantification variables = %d\n"%n_quant)
            for i in range(0, n_quant):
                f_out.write("\nEigen value = %-10.5f\n"%eigen_val[i])
                f_out.write("Eigen vector =\n")
                for j in range(0, var_cond[i_var]):
                    f_out.write("%20.5f\n"%matOmega[j,i])
            f_out.write("\n")
            for iq in range(0, n_quant):
                Xgen.append(['{0}-{1}'.format(var_names[i_var], iq), z.transpose()[iq]])
                pos_v = pos_v + 1

#
#       Writing the contents of Xgen to the output file
#
f_out.write("")
f_out.write("Results...\n\n")
for i in Xgen:
    f_out.write(mm.get_str(i[0]))
f_out.write("\n")
for i in range(n_data):
    for ix in Xgen:
        f_out.write(mm.get_str(ix[1][i]))
    f_out.write("\n")
            
f_out.close()
print(s_out + " was saved.")

#
#           Output to a CSV file
#
csv_out_fl_nm = input('The name of CSV file for output (*.csv) = ')
f_out = open(csv_out_fl_nm, 'w')
for i in range(len(Xgen)):
    if i < len(Xgen) - 1:
        f_out.write('{},'.format(Xgen[i][0]))
    else:
        f_out.write('{}\n'.format(Xgen[i][0]))
for i in range(n_data):
    for ix in range(len(Xgen)):
        if ix < len(Xgen) - 1:
            f_out.write('{},'.format(mm.check_str(Xgen[ix][1][i])))
        else:
            f_out.write('{}\n'.format(mm.check_str(Xgen[ix][1][i])))

f_out.close()
print(csv_out_fl_nm + ' was saved.')


